#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <conio.h>

#define WIN32_LEAN_AND_MEAN
#define INITGUID

#include <d3d8.h>
#include <d3dx8.h>

#include <fmod.h>

D3DCOLOR brt = 0x00000000;
#define FRAME_RATE 60

#include "CVC-DraculasCurse.h"

// !!!!!! for framerate
LONGLONG freq, tdist, nextframe, ctime;
int thisTime, elapsedTime, lastTime;
int dwFrameCount, dwTime, dwFrames, dwFrameTime;

RECT drect, srect; ///!!!!!!!!!!
MSG msg;

int WINAPI WinMain(HINSTANCE hInstance,      
                   HINSTANCE hPrevInstance,  
                   LPSTR lpCmdLine,         
                   int nCmdShow)             
{   
	WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_OWNDC, MsgProc, 0L, 0L, 
          hInstance, NULL, NULL, NULL, NULL,
          "CVC DC", NULL };
     RegisterClassEx(&wc);

	// Create the application's window
	HWND hWnd = CreateWindow("CVC DC", "CVC Dracula's Curse", 
		WS_POPUPWINDOW, 0, 0, 320, 240, //WS_POPUPWINDOW | WS_VISIBLE, 0, 0, 320, 240,
		NULL, NULL, wc.hInstance, NULL);

	if(!(SUCCEEDED(InitD3D(hWnd)))) {
		return FALSE;
	}

	ShowWindow( hWnd, SW_SHOWDEFAULT );

	FSOUND_Init (24000, 128, 0); //FSOUND_INIT_USEDEFAULTMIDISYNTH);

	//dx8.pd3dDevice->CreateTexture(320, 240, 1, D3DUSAGE_DYNAMIC,
	//	D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, &subBuffer);
	
	QueryPerformanceFrequency((LARGE_INTEGER*)&freq); 
	tdist = freq / FRAME_RATE;
	QueryPerformanceCounter((LARGE_INTEGER*)&ctime);
	nextframe = ctime + tdist;

	srand((int)GetTickCount());

	init_data();

	if (menu()) {
		uninit_data();
		if (dx8.pd3dDevice) dx8.pd3dDevice->Release();
		if (dx8.pD3D) dx8.pD3D->Release();
		CleanUp();

		return(0);
	}

	FMUSIC_FreeSong (bgmusic);

	if (startlevel == 1) {
		sprintf(levelname, "blk101");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Beginning.mid");
		SPintrotext.Create("sprites\\1-01village.png",0xFF0000FF,168,24);

	}
	if (startlevel == 2) {
		sprintf(levelname, "blk201a");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Clockwork4.mid");

	}
	if (startlevel == 3) {
		sprintf(levelname, "blk301a");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Mad Forest.mid");

	}
	if (startlevel == 31) {
		sprintf(levelname, "blk401a");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Dead Beat.mid");

	}
	if (startlevel == 32) {
		sprintf(levelname, "blk40aa");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Anxiety.mid");

	}
	if (startlevel == 33) {
		sprintf(levelname, "blk501a");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Nightmare.mid");

	}
	if (startlevel == 34) {
		sprintf(levelname, "blk601a");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Demon Seed.mid");

	}
	if (startlevel == 61) {
		sprintf(levelname, "blk701a");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Anxiety.mid");

	}
	if (startlevel == 62) {
		sprintf(levelname, "blk801a");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Dejavu2.mid");

	}
	if (startlevel == 63) {
		sprintf(levelname, "blk901a");
		bgmusic = FMUSIC_LoadSong("music\\CV3- Riddle.mid");

	}

	music_play = 0;

	rain_cycles = 0; //!!!
	rain_phase = 0; //!!!

	lvldmg = 2;
	if (startlevel > 30) lvldmg++;
	if (startlevel > 60) lvldmg++;

	death = FMUSIC_LoadSong("music\\CV3- Annihilation.mid");
	gameover = FMUSIC_LoadSong("music\\CV3- Game Over.mid");
	bossfight = FMUSIC_LoadSong("music\\CV3- Boss Fight.mid");

	FMUSIC_SetLooping (death, false);
	FMUSIC_SetLooping (gameover, false);

	intro_phase = 0; // !!!!!!!
	intro_cycles = 0;
	freeze = 255;

	sprintf(oldlevel, levelname);

	exitdoor = 0;
	enterat = 0;

	hearts[0] = 5; hearts[1] = 0;	// !!!!!
	time[0] = 0; time[1] = 0; time[2] = 5; // !!!!!!!
	hero_hp = 16;
	boss_hp = 16;
	bossw_active = 0;

	for (i=0;i<9;i++) score[i] = 0;
	players[0]=2; players[1]=0;
	score_f = 0;
	newlife = 1;

	time_cycles = 60;

	clk_timer = 0;
	oldinv = 0;

	hero_whip = 0;
	hero_weapon = 0;	// !!!!!
	hero_double = 0;
	hero_inv = 0;
	spirit = 0;

	hboost = 0;
	hcycles = 0;

	//!!!!!!!!!!!!
	cloudpos[0] = 0;
	cloudpos[1] = 0;
	cloudpos[2] = 0;

begin:

	if (players[0]+players[1]*10 == -1)
		PostQuitMessage(0);

	exa = 500;

	kd_down = 0;
	kd_up = 0;
	kd_left = 0;
	kd_right = 0;
	kd_a = 0;
	kd_b = 0;

	ddelay = 0;

	hero_climb = 0;

	f_action = 1;
	f_phase = 255;

	sleft = 240;

	if (readlevel() == false) return(false);

	fogx1 = 0;
	fogy1 = 0;
	fogx2 = 0;
	fogy2 = 0;

	if (intro_phase == 0) freeze = 0;

	door_action = 0;

	hero_x = entry_x[enterat] - screen_px;
	hero_y = entry_y[enterat] - screen_py;

	if (exitdoor > 0) {
		exitdoor = 0;
		for (i=0;i<n_doors;i++) {
			if (hero_y+screen_py-240 == door_y[i] && hero_x+screen_px > door_x[i] 
				&& hero_x+screen_px < door_x[i]+500) {
				exitdoor = i+1;
				door_action = 3;
				door_cycles = 57;
				door_phase = 12;
				hero_x -= 3*240;
				freeze = 1;
			}
		}
	}

	enemy_number = 0;
	dhurnum = 0;
	item_number = 0;
	debris_number = 0;

	hero_onobj = 0;
	hero_ontype = 0;

	hero_action = 0;
	hero_frame = 0;
	
	if (entry_type[enterat] > 99) {
		hero_onobj = entry_type[enterat]-99;
		hero_ontype = 0;
		hero_action = 1;
		hero_climb = 20;
		door_action = 7;
		door_cycles = 40; // 50
		if (hero_y < 500) door_cycles = 60;
		freeze = 1;
		if (stairs_dir[hero_onobj-1] == hero_dir) {
			if (myRand(0,99) > 49) hero_frame = 48;
				else hero_frame = 51;
		}
		else {
			if (myRand(0,99) > 49) hero_frame = 54;
				else hero_frame = 57;
		}
		//if (hero_dir == 0) hero_x -= 30;
		hero_x -= 20;
	}
	
	hero_dir = entry_dir[enterat];	
	hero_difframe = 1;
	hero_cycles = 12;
	hero_wcycles = 0;
	hero_cjdir = 0;
	hero_lcycles = 0;
	hero_losehp = 0;
	hero_icycles = 0;
	hero_iphase = 0;
	hero_throw = 0;
	hero_hittype = 0;

	spark_v = 0;
	blink_cycles = 4;
	blink_phase = 0;

	Abutton = 0;
	Bbutton = 0;

	n_sub = 0;

	aniphase = 0;
	anicycles = 20;

	crest_out = 0;

	for (i=0;i<10;i++) {
		h_cycles[i] = 30;
		h_dir[i] = 1;
	}

	kills = 0;
	subkills = 0;
	
    if (music_play == 0 && freeze == 0) {
		FMUSIC_PlaySong(bgmusic);
		music_play = 1;
	}

	// main loop

	while (TRUE) { 
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
			if (msg.message == WM_QUIT) {
				break;
			}			
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else {
			chk_spawn();
			if (Handle_Actions()) {
				unloadlevel();
				goto begin;
			}			
			Handle_Subweapons();
			Handle_Enemies();
			Handle_Items();
			Handle_Debris();

			Render();

		}
	}

	// main loop end

	unloadlevel();
	uninit_data();
	CleanUp();

	return(false);

}

#include "enemies.cpp"
#include "init.cpp"
#include "items.cpp"
#include "actions.cpp"
#include "level.cpp"
#include "menu.cpp"
#include "misc.cpp"
#include "render.cpp"
#include "spawn.cpp"
#include "boss.cpp"

LRESULT WINAPI MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {
		case WM_DESTROY:
			PostQuitMessage(0);
		break;

		case WM_KEYDOWN:
			switch(wParam) {
				case VK_ESCAPE:
					DestroyWindow(hWnd);
				break;

				case VK_DOWN:
					kd_down = 1;
				break;

				case VK_UP:
					kd_up = 1;
				break;

				case VK_LEFT:
					kd_left = 1;
				break;

				case VK_RIGHT:
					kd_right = 1;
				break;

			/*	case 0x43:
					kd_down = 1;
				break;

				case 0x48:
					kd_up = 1;
				break;

				case 0x41:
					kd_left = 1;
				break;

				case 0x44:
					kd_right = 1;
				break;*/

				case VK_DELETE:
					kd_b = 1;
				break;

				case VK_END:
					kd_a = 1;
				break;

				case VK_CONTROL:
					kd_b = 1;
				break;

				//case VK_ALT:
				//	kd_a = 1;
				//break;
			}
		break;

		case WM_KEYUP:
			switch(wParam) {
				case VK_DOWN:
					kd_down = 0;
				break;

				case VK_UP:
					kd_up = 0;
				break;

				case VK_LEFT:
					kd_left = 0;
				break;

				case VK_RIGHT:
					kd_right = 0;
				break;

				case VK_DELETE:
					kd_b = 0;
				break;

				case VK_END:
					kd_a = 0;
				break;

				case VK_CONTROL:
					kd_b = 0;
				break;

				//case VK_ALT:
				//	kd_a = 0;
				//break;
			}
		break;

		return 0;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}
