
// function prototypes

LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
HRESULT InitD3D(HWND hWnd);
void Render(void);
void init_data(void);
void uninit_data(void);
void CleanUp(void);
LPDIRECT3DTEXTURE8 LoadTexture(char *filename, D3DCOLOR colorkey);
HRESULT BltSpriteEx( RECT *pDestRect, LPDIRECT3DTEXTURE8 pSrcTexture, 
               RECT *pSrcRect, int dwFlags, D3DCOLOR modulate, 
               float rotation, POINT *prcenter);
//void CalcFrameRate(LPDIRECTDRAWSURFACE7 lpDDSurface);
bool Handle_Actions(void);
void Handle_Enemies(void);
void Handle_Subweapons(void);								
void Handle_Items(void);
void Handle_Debris(void);
void chk_spawn(void);
void chkaction(int index);
void drawbar(void);
int onblock(int obl, int obr, int oby, int type);
int inblock(int obx, int obt, int obb, int ttop);
void scroll(int sdir);
void yscroll(int sdir);
bool readlevel(void);
void unloadlevel(void);
bool RectsOverlap(int x1, int y1, int w1, int h1,
				  int x2, int y2, int w2, int h2);
void shiftenemy(int i2);
void hurthero(int damage);
void inc_score(int v1, int v2, int v3, int v4, int v5);
int myRand(int low, int high);
int menu(void);
int game_over(void);
void handle_boss(void);
void show_intro(void);

// globals
int kd_up, kd_down, kd_left, kd_right, kd_a, kd_b;

int hero_x, hero_y, hero_action, hero_dir, hero_frame, hero_cycles, hero_difframe, hero_climb, hero_oldcframe;
int hero_phase, hero_jdir, hero_wcycles, hero_wphase, hero_hp, hero_onobj, hero_ontype, hero_jsped;
int hero_cjdir, hero_whip, hero_weapon, hero_double, hero_throw, hero_hittype;
int hero_losehp, hero_lcycles, hero_lhpdif, hero_inv, hero_icycles, hero_iphase, inv_dur, hero_hdif;
int ob_onobj, ob_ontype, ob_height;
int n_sub, n_stairs, enemy_number, item_number, debris_number;
int n_spawn, n_zspawn, nbx, nby, lvldmg, n_bg, n_exit, n_entry, n_doors, n_roto;
int n_gears, n_pend, n_crush, n_plat, n_teeter, n_sblock, n_splat;
int screen_px, screen_py, screen_wx, screen_wy, spirit, candle_type;
int fogx1, fogy1, fogx2, fogy2, sway_phase, sway_cycles, rain_phase, rain_cycles;
int boss_hp, boss_ind, boss_maxhp;
int bossw_x, bossw_y, bossw_w, bossw_h, bossw_active;
int oldscore, score_f, newlife, door_action, ddelay, rotoindex;
int clk_timer, clk_x[6], clk_y[6], clk_phase[6], clk_cycles[6], clk_deg[6];
int hboost, hcycles, oldinv, olddur, dhurnum, music_play;
int n_ani, ani_speed;

int x_offset, y_offset;

int exit_p1[10], exit_p2[10], exit_dir[10], exit_entry[10];
int entry_x[10], entry_y[10], entry_type[10], entry_dir[10];
int flag[50];
int stairs_x[20], stairs_y[20], stairs_dir[20], stairs_top[20];
int sub_x[4], sub_y[4], sub_cycles[4], sub_phase[4], sub_type[4];
int sub_dir[4], sub_rect[4][4], sub_extra[4], sub_kills[4];
int door_x[5], door_y[5], door_valid[5], door_pic(5), door_type[5];
int roto_x[10], roto_y[10], roto_spikes[10], roto_cycles[10], roto_phase[10], roto_plat[10];
int gear_x[30], gear_y[30], gear_t[30], gear_s[30], gear_apos[30];
int pend_x[30], pend_y[30], pend_l[30], pend_s[30], pend_pos[30], pend_dif[30];
int pend_cx[30], pend_cy[30], pend_plat[30];
int crush_x[10], crush_y[10], crush_t[10], crush_h[10], crush_p[10];
int crush_d[10], crush_plat[10];
int teeter_x[20], teeter_y[20], teeter_r[20], splat_x[20], splat_p[20];
int splat_s[20], splat_plat[20], sblock_x[50], sblock_y[50], sblock_t[50];
int sblock_extra[50], sblock_phase[50], sblock_cycles[50];
int shadow_cycles[4], h_cycles[10], h_dir[10], cloudpos[3];
int del[10];
int spawn_x[50], spawn_y[50], spawn_dir[50], spawn_exist[50], spawn_type[50], spawn_extra[50];
int zspawn_l[30], zspawn_r[30], zspawn_y[30], zspawn_no[30], zspawn_dur[30], zspawn_cycles[30];
int zspawn_type[30], zspawn_top[30], zspawn_bottom[30], zspawn_extra[30];
int ani_x[500], ani_y[500], ani_t[500], ani_o[500];

char levelname[255], exit_file[20][10];
short int num_ftiles, num_fstairs, n_anit;

char test1[255];

int level[100][100], bgA[100][100], bgB[100][100], tbsx[2], tbsy[2], bnbx[2], bnby[2];
int backgn[8], bgx[8], bgy[8], bgsx[8], bgsy[8], bgloop[8];
int score[9], block[3], hearts[2], players[2], time[3];
int hero_rect[4], hero_wrect[4];

// classes

class DX8VARS {
public:
     LPDIRECT3D8 pD3D;

     LPDIRECT3DDEVICE8 pd3dDevice;

     LPD3DXSPRITE pd3dxSprite;

     D3DCAPS8 *pd3dcaps;

     DX8VARS() { pD3D = NULL; pd3dDevice = NULL; pd3dxSprite = NULL;
          pd3dcaps = new D3DCAPS8; }
     ~DX8VARS() { if (pd3dcaps) delete pd3dcaps; }
};

class Enemy {
public:
	int x, y, etype, rect1, rect2, rect3, rect4, cycles;
	int phase, dir, d_item, hp, special, spawned, difphase;
	int stopped, extra, action;

	Enemy() { action = -1; }
};

class DCItem {
public:
	int x, y, itype, rect1, rect2, rect3, rect4;
	int phase, cycles, falling, dur;

	DCItem() { itype = -1; }
};

class DCDebris {
public:
	int x, y, dtype, type2, dir, xdif;
	int phase, cycles, dur, speed, turn;

	DCDebris() { phase = -1; }
};

class Tile {
public:
	int pic, stair, top, side;

	Tile() { pic = -1; stair = -1; top = 0; side = 0; }
};

class Sprite {
public:
	LPDIRECT3DTEXTURE8 tex;
	int frameWidth, frameHeight, imageWidth;

	Sprite() { tex = NULL; frameWidth = 0; frameHeight = 0;}

	void Create(char *fname, int mcolor, int fw, int fh, int iw) {
		tex = LoadTexture(fname, mcolor);
		frameWidth = fw;
		frameHeight = fh;
		imageWidth = iw;
	}

	void Create(char *fname, int mcolor, int fw, int fh) {
		tex = LoadTexture(fname, mcolor);
		frameWidth = fw;
		frameHeight = fh;
		imageWidth = 256;
	}

	void Draw(int dx, int dy, int dframe, int dir, int size, int rotate, D3DCOLOR modulate) {
		int i;
		RECT drect, srect;

		drect.left = dx;
		drect.right = dx+(frameWidth*size)/100;
		drect.top = dy;
		drect.bottom = dy+(frameHeight*size)/100;

		srect.left = 0;
		srect.top = 0;

		for (i=0;i<dframe;i++) {
			srect.left += frameWidth;
			if (srect.left+frameWidth > imageWidth) {
				srect.left = 0;
				srect.top += frameHeight;
			}	
		}

		srect.right = srect.left + frameWidth;
		srect.bottom = srect.top + frameHeight;

		if (modulate == 0) modulate = 0xFFFFFFFF - brt;

		BltSpriteEx(&drect,tex,&srect,dir,modulate,
			(((float)rotate*3.141592654f)/1800.0f),NULL);
	}

};

class Platf {
public:
	int x, y, width, obj, obj_type;
	bool active;

	Platf() { x = 0; y = 0; width = 0; obj = -1; obj_type = -1; active = true;}

	void Create(int cr_x, int cr_y, int cr_w, int cr_obj, int cr_objt) {
		x = cr_x; y = cr_y;
		width = cr_w;
		obj = cr_obj; obj_type = cr_objt;
		active = true;
	}

	void enable(bool status) {
		active = status;
	}

	void move(int mx, int my) {
		x += mx; y += my;
		if (hero_ontype == obj_type && hero_onobj-1 == obj) {
			hero_x += mx; hero_y += my;
		}
	}
};

// global variables

DX8VARS dx8;

Sprite SPHero, SPWhip[3], SPfont, SPbars, SPiwindow, SPblack;
Sprite SPaxe, SPdagger, SPwater, SPcross, SPwatch;
Sprite SPcruz, SPcandle, SPcandlefire, SPtorch, SPitems, SPdoor[4], SPrblock, SPsblock;
Sprite SPbat, SPskeleton, SPigor, SPmedusahead, SPbonepillar, SPzombie, SPfireball;
Sprite SPboss, SPspearman, SPspecter, SPdhuron;
Sprite SPbone, SPsparks, SPburn, SPsparklies, SPscoref, SPenemydeath, SPdust;
Sprite SPgear[3], SPpend, SPpendbar, SPcrusher[3], SPcrumble, SPteeter;
Sprite SPintrorec, SPintrotext;
Sprite SPfog1, SPfog2, SPrain, SPclouds[3];

LPDIRECT3DTEXTURE8 subBuffer;

Platf platforms[30];

FSOUND_SAMPLE* FX_leather,* FX_chain,* FX_vk,* FX_ghit1,* FX_ghit2,* FX_dead,* 
	FX_weaponpick,* FX_thud,* FX_hit1,* FX_fire,* FX_sheart,* FX_lheart,* FX_double,* FX_dagger,*
	FX_brang,* FX_money,* FX_crest,* FX_axe,* FX_break,* FX_dooropen,* FX_doorslam,* FX_fireshort,*
	FX_bpillardeath,* FX_batdeath,* FX_rblock,* FX_meat,* FX_skeletondeath,* FX_mheaddeath,*
	FX_wallbreak,* FX_zombiedeath,* FX_igordeath,* FX_igor,* FX_batswoop,* FX_pause,* FX_rosary,*
	FX_clock,* FX_crumble[5];
FMUSIC_MODULE* bgmusic,* death,* gameover,* bossfight;

Sprite tiles[256], anis[50], stairs[20], backg[8];
Enemy e[20];
DCItem it[15];
DCDebris db[200];
Tile t[256];

int Abutton, Bbutton, command;

int hero_wframe, afact, exitdoor, enterat, time_cycles;
int intro_cycles, intro_phase, intro_textdist;
int f_action, f_phase, freeze, i, i2, i3;
int door_cycles, door_phase, anicycles, aniphase;
int spark_v, blink_cycles, blink_phase, crest_out;
int kills, subkills, oldx, sleft, dx, exa;
int startlevel;
char oldlevel[255];
