HRESULT InitD3D(HWND hWnd)
{
	if ((dx8.pD3D = Direct3DCreate8(D3D_SDK_VERSION)) == NULL) return E_FAIL;

	D3DDISPLAYMODE d3ddm;

	if (FAILED(dx8.pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT,&d3ddm)))
		return E_FAIL;

	d3ddm.Format = D3DFMT_R5G6B5;
	d3ddm.Width = 320;
	d3ddm.Height = 240;

	D3DPRESENT_PARAMETERS d3dpp; 
	ZeroMemory(&d3dpp, sizeof(d3dpp));
	d3dpp.Windowed = FALSE;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferWidth = d3ddm.Width;
	d3dpp.BackBufferHeight = d3ddm.Height;
	d3dpp.BackBufferFormat = d3ddm.Format;
	d3dpp.hDeviceWindow = hWnd;
	d3dpp.FullScreen_RefreshRateInHz = D3DPRESENT_RATE_DEFAULT;
	d3dpp.FullScreen_PresentationInterval = D3DPRESENT_INTERVAL_ONE;

	if (FAILED(dx8.pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL,hWnd,
		D3DCREATE_SOFTWARE_VERTEXPROCESSING,&d3dpp, &dx8.pd3dDevice)))
			return E_FAIL;
	
	D3DXCreateSprite(dx8.pd3dDevice, &dx8.pd3dxSprite);

	ShowCursor(FALSE);

	return S_OK;	
}

void init_data(void)
{
	// video data
	SPHero.Create("sprites\\Trevor-Spriteset2.png",0xFFFFFFFF,51,48,510);

	SPblack.Create("sprites\\black.png",0,32,32);
	//SPcruz.Create("sprites\\crucifix.png",0xFFFFFFFF,96,144);
	
	SPWhip[0].Create("sprites\\WhipLeather.png",0xFFFFFFFF,128,54);
	SPWhip[1].Create("sprites\\WhipChain.png",0xFFFFFFFF,128,54);
	SPWhip[2].Create("sprites\\WhipVK.png",0xFFFFFFFF,128,54);

	SPfont.Create("sprites\\CV3font1.png",0xFFFFFFFF,8,8,121);
	SPbars.Create("sprites\\barblock.png",0xFF000000,4,8);
	SPiwindow.Create("sprites\\Itemwindow.png",0xFF000000,32,24);
	SPitems.Create("sprites\\Items.png",0xFFFFFFFF,24,24);
	SPaxe.Create("sprites\\Axe.png",0xFF00007F,32,32);
	SPdagger.Create("sprites\\Dagger.png",0xFFFFFFFF,32,2);
	SPwater.Create("sprites\\Holywater.png",0xFF000000,34,48);
	SPcross.Create("sprites\\Cross.png",0xFF000000,20,20);
	SPwatch.Create("sprites\\pocketwatch.png",0xFFFFFFFF,16,16);


	// only load stuff that's actually used!
	SPbat.Create("sprites\\Bat.png",0xFFFF00FF,16,48);
	SPskeleton.Create("sprites\\skeleton1.png",0xFFBFBFFF,38,52,304);
	SPmedusahead.Create("sprites\\medusaheads.png",0xFFFFFFFF,24,24);
	SPigor.Create("sprites\\igor.png",0xFFFFFFFF,16,24);
	SPzombie.Create("sprites\\zombie6.png",0xFFFFFFFF,32,48);
	SPspearman.Create("sprites\\spearman1.png",0xFFFFFFFF,28,52);
	SPbonepillar.Create("sprites\\bonepillar.png",0xFF0000FF,32,48);
	SPfireball.Create("sprites\\fireball1.png",0xFFFFFFFF,12,9);
	SPspecter.Create("sprites\\specter2.png",0xFFFF00FF,20,20);
	SPdhuron.Create("sprites\\dhuron1.png",0xFFFFFFFF,92,80,368);

	SPfog1.Create("sprites\\mist1.png",0,256,224);
	SPfog2.Create("sprites\\mist2.png",0,256,224);
	SPrain.Create("sprites\\rainfx.png",0xFF000000,64,64);
	SPclouds[0].Create("sprites\\cloudfx scroll1.png",0xFF000000,256,24);
	SPclouds[1].Create("sprites\\cloudfx scroll2.png",0xFF000000,256,24);
	SPclouds[2].Create("sprites\\cloudfx scroll3.png",0xFF000000,256,32);

	SPcandle.Create("sprites\\Candle.png",0xFFFFFFFF,12,24);
	SPcandlefire.Create("sprites\\CandleFire.png",0xFF000000,24,24);
	SPtorch.Create("sprites\\Torch.png",0xFFFFFFFF,24,48);
	SPrblock.Create("sprites\\rotoblock1.png",0xFF000000,48,48);
	SPsblock.Create("sprites\\rotoblock2.png",0xFF000000,48,48);
	SPgear[0].Create("sprites\\gear1.png",0xFFFFFFFF,216,216);
	SPgear[1].Create("sprites\\gear2.png",0xFF000000,120,120);
	SPgear[2].Create("sprites\\gear3.png",0xFF000000,120,120);
	SPpend.Create("sprites\\pendulum.png",0xFFFFFFFF,48,48);
	SPpendbar.Create("sprites\\pendulumbar2.png",0xFF000000,5,23);
	SPcrusher[0].Create("sprites\\spike4.png",0xFFFFFFFF,48,24);
	SPcrusher[1].Create("sprites\\spike2.png",0xFFFFFFFF,48,12);
	SPcrusher[2].Create("sprites\\spike3.png",0xFFFFFFFF,48,12);
	SPteeter.Create("sprites\\teetertotter.png",0xFF000000,145,9);

	SPdoor[0].Create("sprites\\door1.png",0xFFFFFFFF,36,72);
	SPdoor[1].Create("sprites\\door2.png",0xFFFFFFFF,36,72);
	SPdoor[2].Create("sprites\\door3.png",0xFFFFFFFF,36,72);
	SPdoor[3].Create("sprites\\door4.png",0xFFFFFFFF,36,72);
	// ---------------------------------------------------------------

	SPsparks.Create("sprites\\sparkstuff.png",0xFF000000,24,24);
	SPbone.Create("sprites\\bone2.png",0xFFFF00FF,16,16);
	SPsparklies.Create("sprites\\crosssparklie.png",0xFF000000,16,16);
	SPscoref.Create("sprites\\bonusscore.png",0xFF0000FF,6,8);
	SPenemydeath.Create("sprites\\enemydeath3.png",0xFFFFFFFF,16,16);
	SPdust.Create("sprites\\floordust.png",0xFFFF00FF,20,20);
	SPcrumble.Create("sprites\\crumbleblock.png",0xFFFFFFFF,24,24);

	SPintrorec.Create("sprites\\sotntriangle3.png",0xFF000000,56,48);

	// sound
	FX_leather = FSOUND_Sample_Load (FSOUND_FREE,"sound\\whipleather.wav",0,0,0);
	FX_chain = FSOUND_Sample_Load (FSOUND_FREE,"sound\\whip3.wav",0,0,0);
	FX_vk = FSOUND_Sample_Load (FSOUND_FREE,"sound\\whip2.wav",0,0,0);
	FX_ghit1 = FSOUND_Sample_Load (FSOUND_FREE,"sound\\gethit6.wav",0,0,0);
	FX_ghit2 = FSOUND_Sample_Load (FSOUND_FREE,"sound\\gethit5.wav",0,0,0);
	FX_dead = FSOUND_Sample_Load (FSOUND_FREE,"sound\\dying2.wav",0,0,0);
	FX_weaponpick = FSOUND_Sample_Load (FSOUND_FREE,"sound\\weaponpickup2.wav",0,0,0);
	FX_thud = FSOUND_Sample_Load (FSOUND_FREE,"sound\\fallcrouch.wav",0,0,0);
	FX_hit1 = FSOUND_Sample_Load (FSOUND_FREE,"sound\\hit1.wav",0,0,0);
	FX_fire = FSOUND_Sample_Load (FSOUND_FREE,"sound\\destructionfire.wav",0,0,0);
	FX_sheart = FSOUND_Sample_Load (FSOUND_FREE,"sound\\sheart1.wav",0,0,0);
	FX_lheart = FSOUND_Sample_Load (FSOUND_FREE,"sound\\lheart1.wav",0,0,0);
	FX_double = FSOUND_Sample_Load (FSOUND_FREE,"sound\\weaponpickup3.wav",0,0,0);
	FX_dagger = FSOUND_Sample_Load (FSOUND_FREE,"sound\\dagger1.wav",0,0,0);
	FX_brang = FSOUND_Sample_Load (FSOUND_FREE,"sound\\brang3.wav",0,0,0);
	FX_money = FSOUND_Sample_Load (FSOUND_FREE,"sound\\money.wav",0,0,0);
	FX_crest = FSOUND_Sample_Load (FSOUND_FREE,"sound\\whippowerup.wav",0,0,0);
	FX_axe = FSOUND_Sample_Load (FSOUND_FREE,"sound\\axe.wav",0,0,0);
	FX_break = FSOUND_Sample_Load (FSOUND_FREE,"sound\\holywater.wav",0,0,0);
	FX_dooropen = FSOUND_Sample_Load (FSOUND_FREE,"sound\\opendoor3.wav",0,0,0);
	FX_doorslam = FSOUND_Sample_Load (FSOUND_FREE,"sound\\doorslam.wav",0,0,0);
	FX_fireshort = FSOUND_Sample_Load (FSOUND_FREE,"sound\\fireshort.wav",0,0,0);
	FX_bpillardeath = FSOUND_Sample_Load (FSOUND_FREE,"sound\\bpillardeath.wav",0,0,0);
	FX_batdeath = FSOUND_Sample_Load (FSOUND_FREE,"sound\\batdeath.wav",0,0,0);
	FX_rblock = FSOUND_Sample_Load (FSOUND_FREE,"sound\\roto2.wav",0,0,0);
	FX_meat = FSOUND_Sample_Load (FSOUND_FREE,"sound\\restore3.wav",0,0,0);
	FX_skeletondeath = FSOUND_Sample_Load (FSOUND_FREE,"sound\\skeletondeath2.wav",0,0,0);
	FX_mheaddeath = FSOUND_Sample_Load (FSOUND_FREE,"sound\\mheaddeath.wav",0,0,0);
	FX_wallbreak = FSOUND_Sample_Load (FSOUND_FREE,"sound\\wallbreak.wav",0,0,0);
	FX_zombiedeath = FSOUND_Sample_Load (FSOUND_FREE,"sound\\zombiedeath.wav",0,0,0);
	FX_igordeath = FSOUND_Sample_Load (FSOUND_FREE,"sound\\igordeath.wav",0,0,0);
	FX_igor = FSOUND_Sample_Load (FSOUND_FREE,"sound\\igor.wav",0,0,0);
	FX_batswoop = FSOUND_Sample_Load (FSOUND_FREE,"sound\\batswoop.wav",0,0,0);
	FX_pause = FSOUND_Sample_Load (FSOUND_FREE,"sound\\pause.wav",0,0,0);
	FX_rosary = FSOUND_Sample_Load (FSOUND_FREE,"sound\\Rosary1.wav",0,0,0);
	FX_clock = FSOUND_Sample_Load (FSOUND_FREE,"sound\\Pocketwatch2.wav",0,0,0);
	FX_crumble[0] = FSOUND_Sample_Load (FSOUND_FREE,"sound\\Crumble1.wav",0,0,0);
	FX_crumble[1] = FSOUND_Sample_Load (FSOUND_FREE,"sound\\Crumble2.wav",0,0,0);
	FX_crumble[2] = FSOUND_Sample_Load (FSOUND_FREE,"sound\\Crumble3.wav",0,0,0);
	FX_crumble[3] = FSOUND_Sample_Load (FSOUND_FREE,"sound\\Crumble4.wav",0,0,0);
	FX_crumble[4] = FSOUND_Sample_Load (FSOUND_FREE,"sound\\Crumble5.wav",0,0,0);

}


LPDIRECT3DTEXTURE8 LoadTexture(char *filename, D3DCOLOR colorkey)
{
	LPDIRECT3DTEXTURE8 pd3dTexture = NULL;
	D3DXIMAGE_INFO SrcInfo;

	D3DXCreateTextureFromFileEx( dx8.pd3dDevice, filename, 0, 0, 1, 0, 
		D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, D3DX_FILTER_NONE, D3DX_DEFAULT, 
		colorkey, &SrcInfo , NULL, &pd3dTexture);
	return pd3dTexture;
}

void uninit_data(void)
{
	// use safe release
	SPHero.tex->Release();

	SPbat.tex->Release();
	SPskeleton.tex->Release();
	SPmedusahead.tex->Release();
	SPigor.tex->Release();
	SPzombie.tex->Release();
	SPspearman.tex->Release();
	SPbonepillar.tex->Release();
	SPfireball.tex->Release();
	SPspecter.tex->Release();
	SPdhuron.tex->Release();

	SPblack.tex->Release();
	
	SPWhip[0].tex->Release();
	SPWhip[1].tex->Release();
	SPWhip[2].tex->Release();

	SPfont.tex->Release();
	SPbars.tex->Release();
	SPiwindow.tex->Release();
	SPitems.tex->Release();
	SPaxe.tex->Release();
	SPdagger.tex->Release();
	SPwater.tex->Release();
	SPcross.tex->Release();
	SPwatch.tex->Release();

	SPcandle.tex->Release();
	SPcandlefire.tex->Release();
	SPtorch.tex->Release();
	SPrblock.tex->Release();
	SPsblock.tex->Release();
	SPgear[0].tex->Release();
	SPgear[1].tex->Release();
	SPgear[2].tex->Release();
	SPpend.tex->Release();
	SPpendbar.tex->Release();
	SPcrusher[0].tex->Release();
	SPcrusher[1].tex->Release();
	SPcrusher[2].tex->Release();

	SPdoor[0].tex->Release();
	SPdoor[1].tex->Release();
	SPdoor[2].tex->Release();
	SPdoor[3].tex->Release();

	SPfog1.tex->Release();
	SPfog2.tex->Release();

	SPsparks.tex->Release();
	SPbone.tex->Release();
	SPsparklies.tex->Release();
	SPscoref.tex->Release();
	SPenemydeath.tex->Release();
	SPdust.tex->Release();

	SPrain.tex->Release();
	SPclouds[0].tex->Release();
	SPclouds[1].tex->Release();
	SPclouds[2].tex->Release();
	
	SPteeter.tex->Release();
	SPcrumble.tex->Release();
	
	SPintrorec.tex->Release();

/*	FSOUND_Sample_Free (FX_leather);		FSOUND_Sample_Free (FX_chain);	FSOUND_Sample_Free (FX_vk);
	FSOUND_Sample_Free (FX_ghit1);		FSOUND_Sample_Free (FX_ghit2);	FSOUND_Sample_Free (FX_dead);
	FSOUND_Sample_Free (FX_weaponpick);	FSOUND_Sample_Free (FX_thud);		FSOUND_Sample_Free (FX_hit1);
	FSOUND_Sample_Free (FX_fire);			FSOUND_Sample_Free (FX_sheart);	FSOUND_Sample_Free (FX_lheart);
	FSOUND_Sample_Free (FX_double);		FSOUND_Sample_Free (FX_dagger);	FSOUND_Sample_Free (FX_brang);
	FSOUND_Sample_Free (FX_money);		FSOUND_Sample_Free (FX_crest);	FSOUND_Sample_Free (FX_axe);
	FSOUND_Sample_Free (FX_break);		FSOUND_Sample_Free (FX_dooropen);	FSOUND_Sample_Free (FX_doorslam);
	FSOUND_Sample_Free (FX_fireshort);	FSOUND_Sample_Free (FX_bpillardeath);
	FSOUND_Sample_Free (FX_batdeath);		FSOUND_Sample_Free (FX_rblock);	FSOUND_Sample_Free (FX_meat);
	FSOUND_Sample_Free (FX_skeletondeath);						FSOUND_Sample_Free (FX_mheaddeath);
	FSOUND_Sample_Free (FX_wallbreak);	FSOUND_Sample_Free (FX_zombiedeath);
	FSOUND_Sample_Free (FX_igordeath);	FSOUND_Sample_Free (FX_igor);		FSOUND_Sample_Free (FX_batswoop);
	FSOUND_Sample_Free (FX_pause);		FSOUND_Sample_Free (FX_rosary);	FSOUND_Sample_Free (FX_clock);
	FSOUND_Sample_Free (FX_crumble[0]);	FSOUND_Sample_Free (FX_crumble[1]); FSOUND_Sample_Free (FX_crumble[2]);
	FSOUND_Sample_Free (FX_crumble[3]);	FSOUND_Sample_Free (FX_crumble[4]);*/

	FMUSIC_FreeSong (bgmusic);
	FMUSIC_FreeSong (death);
	FMUSIC_FreeSong (gameover);
	FMUSIC_FreeSong (bossfight);
}

void CleanUp(void)
{
	
	if (dx8.pd3dDevice) dx8.pd3dDevice->Release();

	if (dx8.pD3D) dx8.pD3D->Release();

	FSOUND_Close();
}